## How to contribute to *activity_notification*

#### **Did you find a bug?**

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/simukappu/activity_notification/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/simukappu/activity_notification/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible.

#### **Did you write code set for a new feature or a patch that fixes a bug?**

* Open a new GitHub pull request with your code set.

* Ensure the pull request description clearly describes the problem and solution. Include the relevant issue number if applicable.

* Before submitting, please check the followings:
  * Write tests with RSpec to cover your changes
  * Write code documents as YARD format to cover your changes
  * Write [README](/README.md) and [Functions](/docs/Functions.md) documents if applicable

#### **Did you fix whitespace, format code, or make a purely cosmetic patch?**

* Feel free to create a new GitHub pull request.

* If changes that are cosmetic in nature and do not add anything substantial to the stability, functionality, or testability of the gem may not be accepted.

#### **Do you intend to add a new feature or change an existing one?**

* Open an issue on GitHub to suggest your change and collect feedback about the change.

#### **Do you have questions about the source code?**

* If you're unable to find any answers from public information and your own investigation, you can ask any questions about how to use *activity_notification* by creating GitHub issue.

*activity_notification* is a volunteer effort. We appreciate any of your contribution!

Thank you!